# Slune
# Copyright (C) 2002-2003 Jean-Baptiste LAMY
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import soya, soya.soya3d as soya3d, soya.model as model
import editobj, editobj.editor as editor
import soya.editor, soya.editor.world
from soya.math3d import Point, Vector

import slune.level, slune.race, slune.fight, slune.character

editobj.EVAL_ENV.update({
  "race"  : slune.race,
  "fight" : slune.fight,
  })

editor.register_attr("script"               , editor.TextEditor)
editor.register_attr("init_script"          , editor.TextEditor)
editor.register_attr("init_character_script", editor.TextEditor)
editor.register_attr("start_script"         , editor.TextEditor)
editor.register_attr("end_script"           , editor.TextEditor)
editor.register_attr("static_part"          , soya.editor.WorldEditor)

slune.race.Flag            .__clickmanager__ = soya.editor.world.MoveClickManager
slune.level.SphericalScript.__clickmanager__ = soya.editor.world.MoveClickManager
slune.character.Pushable   .__clickmanager__ = soya.editor.world.MoveClickManager

def _add_flag           (root, current): slune.race.Flag(root)
def _add_sphericalscript(root, current): slune.level.SphericalScript(root)
def _add_barrier        (root, current): slune.character.Barrier(root)
def _put_down(root, current):
  cursor = root.parent.parent["cursor"]
  
  result = root.raypick(cursor, Vector(root, 0.0, -1.0, 0.0), -1.0, 2)
  
  if result:
    p, v = result
    cursor.add_vector(cursor >> p)
    cursor.button_pressed(1)
    cursor.button_released(1)

soya.editor.world.KEY_BINDINGS[soya.K_d] = _put_down
soya.editor.world.KEY_BINDINGS[soya.K_f] = _add_flag
soya.editor.world.KEY_BINDINGS[soya.K_s] = _add_sphericalscript
soya.editor.world.KEY_BINDINGS[soya.K_b] = _add_barrier
