# launch this script to generate the level (lavel at the mountain)

import math, os, os.path
import copy

import soya
import soya.model  as model
import soya.soya3d as soya3d
import soya.editor.main
import soya.land

import slune.level


root = soya3d.World()
w = soya3d.World(root)
w.set_xyz(-20.0, -20.0, -20.0)
atm = soya3d.Atmosphere()
atm.ambient = (0.3, 0.3, 0.3, 1.0)
atm.bg_color  = (0.2, 0.1, 0.4, 1.0)
atm.skyplane = 1
atm.sky_color = (1.0, 1.0, 0.5, 1.0)
atm.fog_color = (0.2, 0.1, 0.4, 1.0)
atm.fog_type    = 0
atm.fog_start   = 10.0
atm.fog_end     = 50.0
atm.fog         = 1
atm.fog_density = 0.0
atm.cloud = model.Material.get("clouds1")
w.atmosphere = atm
land = soya.land.Land()
land.from_image(os.path.join(model.Image.PATH, "canion.png"))
land.map_size = 8
land.scale_factor = 1.5
land.texture_factor = 0.5
land.multiply_height(50.0)
land.set_texture_layer(model.Material.get("jungle1"),  0.0,  15.0)
land.set_texture_layer(model.Material.get("rocks1"), 15.0,  21.0)
land.set_texture_layer(model.Material.get("glace1"),  21.0, 26.0)
land.set_texture_layer(model.Material.get("snow1"),  26.0, 50.0)
w.set_shape(land)
w.y = -35.0
light = soya3d.Light(w)
light.set_xyz(20.0, 30.0, 20.0)

root.filename = "canion-level"
root.save()

print "Done."
